/* Created by Anjuta version 0.1.10-pre */
/*	This file will not be overwritten */

#include <iostream>
#include <iomanip>
#include "PhysicsFS.h"

int main()
{
	PhysicsFS *myfs;
	PhysicsStream *mystream;
	char buff[64]="hello\n\0";

	myfs = new PhysicsFS();
	myfs->Init("/home/urkle/temp/");
	myfs->AddPath("/home/urkle/temp/",false);
	myfs->AddPath("/home/urkle/temp2/",false);
	if (!myfs->writedir("/home/urkle/temp2/"))
		cerr << "Error setting writedir\n";
	cout << myfs->basedir() << "\n";
	cout << myfs->writedir() << "\n";

	mystream = new PhysicsStream("/test.txt",ios::out);
	mystream->write(buff,strlen(buff));
	*mystream << "Test\nwalking\nHello out there in TV land\n";
	cout << "pos: " << mystream->tellg() << "\n";
	mystream->close();

	if (myfs->exists("/test.txt") )
		cout << "File /test.txt exists.\n";

	mystream->open("/test.txt",ios::in);
	mystream->getline(buff,64);
	cout << "getline : " << buff << "\n";
	*mystream >> buff;
	cout << ">> : " << buff << "\n";
	*mystream >> buff;
	cout << ">> : " << buff << "\n";
	cout << "pos: " << mystream->tellg() << "\n";
	mystream->seekg(0);
	cout << "pos: " << mystream->tellg() << "\n";
	*mystream >> buff;
	cout << ">> : " << buff << "\n";
	mystream->close();
	mystream->open("/test2.txt",ios::out);
	*mystream << "test 2";
	mystream->close();
	mystream->open("/test3.txt",ios::out);
	*mystream << "test 3";
	mystream->close();
	mystream->open("/test7.txt",ios::out);
	*mystream << "test 4";
	mystream->close();
	delete mystream;

	PhysicsList *mylist;
	cout << "Directory listing of /\n";
	for (mylist = myfs->ls("/"); mylist->val()!=NULL; (*mylist)++) {
		if (((PhysicsList_ls *)mylist)->isdir())
			cout <<"["<<mylist->val() <<"]\n";
		else
			cout << mylist->val()<<"\n";
	}
	delete mylist;
	cout << "\nCD-ROMS\n";
	for (mylist = myfs->cdromdirs(); mylist->val()!=NULL; (*mylist)++) {
		cout << mylist->val()<<"\n";
	}
	delete mylist;
	cout << "\nSearch Path\n";
	for (mylist = myfs->searchpath(); mylist->val()!=NULL; (*mylist)++) {
		cout << mylist->val()<<"\n";
	}
	delete mylist;
	cout << "\nArchive Info\n";
	for (mylist = myfs->archiveinfo(); mylist->val()!=NULL; (*mylist)++) {
		cout << ((PhysicsList_ArchiveInfo *)mylist)->extension();
		cout << "\n\t" << ((PhysicsList_ArchiveInfo *)mylist)->description();
		cout << "\n\t" << ((PhysicsList_ArchiveInfo *)mylist)->author();
		cout << "\n\t" << ((PhysicsList_ArchiveInfo *)mylist)->url() <<"\n";
	}
	delete mylist;
	delete myfs;
	return (0);
}

